#    Import the standard modules
import Tkinter

#    Import the Chimera modules and classes
import chimera
from chimera.baseDialog import ModelessDialog
from CGLtk import Hybrid

# -----------------------------------------------------------------------------

class PickParticleDialog(ModelessDialog):

    name = "Pick Particle"
    buttons = ("Options", "Close")
    help = "file://"+chimera.pathFinder().dataRoot+"/PickParticle/PickParticle.html"
    title = "Pick Particle In Map"

    #trow=0
    isdisplay=0
    sphmpid=[]
    tbmpid=[]

    # -------------------------------------------------------------------------
    #    GUI Panel
    def fillInUI(self, parent):

        #    Fill in the GUI
        nrow = 0
        #    Tomogram File
        #tomoEntry = Hybrid.Entry(parent, 'Tomogram File ', 40, browse=True)
        #tomoEntry.frame.grid(row=nrow, column=0, columnspan=2, sticky='ew')
        #self.tomo_file=tomoEntry.variable
        #nrow += 1

        #    Marker File
        tomoidEntry = Hybrid.Entry(parent, 'Tomogram ID ', 5, '0')
        tomoidEntry.frame.grid(row=nrow, column=0, columnspan=2, sticky='w')
        self.tomoid=tomoidEntry.variable
        tomoid_children=tomoidEntry.frame.winfo_children()
        tomoid_children[0].config(font='TkCaptionFont')
        nrow += 1

        markerEntry = Hybrid.Entry(parent, 'Marker File ', 40, browse=True)
        markerEntry.frame.grid(row=nrow, column=0, columnspan=2, sticky='ew')
        self.marker_file=markerEntry.variable
        nrow += 1

        #    Object Style
        objectRadio = Hybrid.Radiobutton_Row(parent, 'Object Style ', ('Sphere', 'Tube'), self.ObjectStyleOption)
        #objectRadio = Hybrid.Radiobutton_Row(parent, 'Object Style ', ('Sphere', 'Tube', 'Plane'))
        objectRadio.frame.grid(row=nrow, column=0, columnspan=1, sticky='w')
        self.object_style=objectRadio.variable
        self.object_style.set('Sphere',invoke_callbacks=False)
        nrow += 1

        #    Sampling
        sFrame = Tkinter.Frame(parent)
        sFrame.grid(row=nrow, column=0, columnspan=1, sticky='ew')

        sLabel = Tkinter.Label(sFrame)
        sLabel.grid(row=0, column=0, columnspan=1, sticky='w')
        sLabel.configure(text='Sampling ')

        tanEntry = Hybrid.Entry(sFrame, 'Tangential ',5,'0.0')
        tanEntry.frame.grid(row=0, column=1, columnspan=1, sticky='e')
        self.tangent=tanEntry.variable

        axEntry = Hybrid.Entry(sFrame, ' Axial ',5,'0.0')
        axEntry.frame.grid(row=0, column=2, columnspan=1, sticky='ew')
        self.axial=axEntry.variable
        self.axial_children=axEntry.frame.winfo_children()
        self.axial_children[0].config(state='disabled')
        self.axial_children[1].config(state='disabled')

        randPhi = Hybrid.Checkbutton(parent, 'Random Phi', 1)
        randPhi.button.grid(row=nrow, column = 1, sticky = 'e')
        self.rPhi_box = randPhi.variable
        #randPhi.callback(self.rPhi_box_cb)
        nrow += 1

        self.panel=Tkinter.Frame(parent)
        self.panel.grid(row=nrow, column=0, columnspan=2, sticky='ew')
        #self.trow=nrow
        #self.panel = parent
        nrow += 1

        btFrame = Tkinter.Frame(parent)
        btFrame.grid(row=nrow, column=0, columnspan=2, sticky='ew')
        rsButton = Tkinter.Button(btFrame, text='Reset', command=self.Reset)
        rsButton.pack(side='right', anchor='e')
        svButton = Tkinter.Button(btFrame, text='Save', command=self.Save)
        svButton.pack(side='right', anchor='e')
        dpButton = Tkinter.Button(btFrame, text='Display', command=self.Display)
        dpButton.pack(side='right', anchor='e')
        nrow += 1

        op = Hybrid.Popup_Panel(parent)
        opf = op.frame
        opf.grid(row=nrow, column=0, columnspan=2, sticky='ew')
        opf.grid_remove()
        opf.columnconfigure(0, weight=1)
        self.options_panel = op.panel_shown_variable
        nrow += 1

        orow = 0
        dummyFrame = Tkinter.Frame(opf, relief='groove', borderwidth=1)
        Tkinter.Frame(dummyFrame).pack()
        dummyFrame.grid(row=orow,column=0,columnspan=2,pady=1,sticky='ew')
        orow += 1

        cb = op.make_close_button(opf)
        cb.grid(row=orow, column=1, sticky = 'e')

        lb0 = Tkinter.Label(opf, text='Combine Coordinates', font='TkCaptionFont')
        lb0.grid(row=orow, column=0, sticky='w', pady=2)
        orow += 1

        self.combEntryI = Hybrid.Entry(opf, 'Multiple Files ', 20, browse=True)
        self.combEntryI.frame.grid(row=orow,column=0,columnspan=2,sticky='ew')
        self.comb_fileI=self.combEntryI.variable
        orow += 1

        self.combEntryO = Hybrid.Entry(opf, 'Combined File ', 20, browse=True)
        self.combEntryO.frame.grid(row=orow,column=0,columnspan=2,sticky='ew')
        self.comb_fileO=self.combEntryO.variable
        self.comb_bgO=self.combEntryO.frame.children.values()[0]
        orow += 1

        reNo = Hybrid.Checkbutton(opf, 'Renumber', 0)
        reNo.button.grid(row=orow, column = 0, sticky = 'e')
        self.reNo_box = reNo.variable

        cbFrame = Tkinter.Frame(opf)
        cbFrame.grid(row=orow, column=1, columnspan=1, sticky='e')
        cbButton = Tkinter.Button(cbFrame, text='Combine', font='TkCaptionFont', command=self.Combine)
        cbButton.pack(side='right', anchor='e')
        orow += 1

        lb1 = Tkinter.Label(opf, text='Shift Coordinates', font='TkCaptionFont')
        lb1.grid(row=orow, column=0, sticky='w', pady=2)
        orow += 1

        self.shiftEntryI = Hybrid.Entry(opf, 'Coordinate File ', 20, browse=True)
        self.shiftEntryI.frame.grid(row=orow,column=0,columnspan=2,sticky='ew')
        self.shift_fileI=self.shiftEntryI.variable
        self.shift_bgI=self.shiftEntryI.frame.children.values()[0]
        orow += 1

        xyzf = Tkinter.Frame(opf)
        xyzf.grid(row=orow, column=0, columnspan=2, sticky='ew')
        xoffsetEntry = Hybrid.Entry(xyzf, 'X-Offset ',5,'0.0')
        xoffsetEntry.frame.grid(row=0, column=0, columnspan=1, sticky='w')
        self.shift_x=xoffsetEntry.variable
        yoffsetEntry = Hybrid.Entry(xyzf, ' Y-Offset ',5,'0.0')
        yoffsetEntry.frame.grid(row=0, column=1, columnspan=1, sticky='w')
        self.shift_y=yoffsetEntry.variable
        zoffsetEntry = Hybrid.Entry(xyzf, ' Z-Offset ',5,'0.0')
        zoffsetEntry.frame.grid(row=0, column=2, columnspan=1, sticky='w')
        self.shift_z=zoffsetEntry.variable
        apixelIEntry = Hybrid.Entry(xyzf, '      Rescale ',5,'1.0')
        apixelIEntry.frame.grid(row=0, column=3, columnspan=1, sticky='w')
        self.apix_in=apixelIEntry.variable
        apixelOEntry = Hybrid.Entry(xyzf, '-',5,'1.0')
        apixelOEntry.frame.grid(row=0, column=4, columnspan=1, sticky='w')
        self.apix_ou=apixelOEntry.variable
        orow += 1

        self.shiftEntryO = Hybrid.Entry(opf, 'Shifted File ', 20, browse=True)
        self.shiftEntryO.frame.grid(row=orow,column=0,columnspan=2,sticky='ew')
        self.shift_fileO=self.shiftEntryO.variable
        self.shift_bgO=self.shiftEntryO.frame.children.values()[0]
        orow += 1

        sfFrame = Tkinter.Frame(opf)
        sfFrame.grid(row=orow, column=1, columnspan=1, sticky='e')
        sfButton = Tkinter.Button(sfFrame, text='Shift', font='TkCaptionFont', command=self.Shift)
        sfButton.pack(side='right', anchor='e')
        orow += 1

    # -------------------------------------------------------------------------
    #    Sphere
    def SphereFrame(self, parent):
        if (self.object_style.get() == 'Sphere'):
            self.objFrame=Tkinter.Frame(parent)
            self.objFrame.grid(row=0, column=0, columnspan=2, sticky='ew')
            #self.objFrame.grid(row=self.trow, column=0, columnspan=2, sticky='ew')

            self.sphereScale=[]
            self.sphererad=[]
            self.sphrad0=[]
            nrow = 0
            defrad = 20
            self.mplist0=chimera.openModels.list()
            for sphname in range(0,self.sphmpid.shape[0]):
                self.sphereScale.append(Hybrid.Scale(self.objFrame, 'Sphere_%s ' % (sphname), 1, 200, 1, defrad))
                self.sphereScale[-1].frame.grid(row=nrow, column=0, columnspan=2, sticky='ew')
                child=self.sphereScale[-1].frame.winfo_children()[2]
                child.config(length=400)
                self.sphererad.append(self.sphereScale[-1].variable)
                self.sphrad0.append(defrad)
                self.SphereModel(sphname)
                nrow += 1

            mplist1=chimera.openModels.list()
            self.sphmplist=[ x for x in mplist1 if not x in self.mplist0 ]
            for sphname in range(0,self.sphmpid.shape[0]):
                self.sphereScale[sphname].callback(self.SphereRadius_cb)
                self.sphereScale[sphname].entry.bind('<KeyPress-Return>', self.SphereRadius_cb)

    #    Sphere Model Initialization
    def SphereModel(self, sphname):
        tmpString="sphere mesh true "
        tmpString+="color yellow radius %g " % int(self.sphererad[sphname].get())
        tmpString+="center %g,%g,%g " % (self.emdata[7,sphname],self.emdata[8,sphname],self.emdata[9,sphname])
        tmpString+="modelName Sphere_%s modelId %s" % (sphname,self.sphmpid[sphname])
        from Shape import shape_command as sc
        sc(None,tmpString)

    #    Sphere Radius
    def SphereRadius_cb(self, event = None):
        if (self.object_style.get() == 'Sphere'):
            for sphname in range(0,self.sphmpid.shape[0]):
                radius=self.sphererad[sphname].get()
                if radius == '':
                    return
                radius=int(radius)
                if self.sphrad0[sphname]!=radius:
                    chimera.openModels.close(self.sphmplist[sphname])
                    self.sphrad0[sphname]=radius
                    tmpString="sphere mesh true "
                    tmpString+="color yellow radius %g " % radius
                    tmpString+="center %g,%g,%g " % (self.emdata[7,sphname],self.emdata[8,sphname],self.emdata[9,sphname])
                    tmpString+="modelName Sphere_%s modelId %s" % (sphname,self.sphmpid[sphname])
                    from Shape import shape_command as sc
                    sc(None,tmpString)
            mplist1=chimera.openModels.list()
            self.sphmplist=[ x for x in mplist1 if not x in self.mplist0 ]

    # -------------------------------------------------------------------------
    #    Tube
    def TubeFrame(self, parent):
        if (self.object_style.get() == 'Tube'):
            self.objFrame=Tkinter.Frame(parent)
            self.objFrame.grid(row=0, column=0, columnspan=2, sticky='ew')
            #self.objFrame.grid(row=self.trow, column=0, columnspan=2, sticky='ew')

            self.tubeScale=[]
            self.tuberad=[]
            self.tbrad0=[]
            nrow = 0
            defrad = 20
            self.mplist0=chimera.openModels.list()
            for tbname in range(0,self.tbmpid.shape[0]):
                self.tubeScale.append(Hybrid.Scale(self.objFrame, 'Tube_%s ' % (tbname), 1, 200, 1, defrad))
                self.tubeScale[-1].frame.grid(row=nrow, column=0, columnspan=2, sticky='ew')
                child=self.tubeScale[-1].frame.winfo_children()[2]
                child.config(length=400)
                self.tuberad.append(self.tubeScale[-1].variable)
                self.tbrad0.append(defrad)
                self.TubeModel(tbname)
                nrow += 1

            mplist1=chimera.openModels.list()
            self.tbmplist=[ x for x in mplist1 if not x in self.mplist0 ]
            for tbname in range(0,self.tbmpid.shape[0]):
                self.tubeScale[tbname].callback(self.TubeRadius_cb)
                self.tubeScale[tbname].entry.bind('<KeyPress-Return>', self.TubeRadius_cb)

    #    Tube Model Initialization
    def TubeModel(self, tbname):
        tmpString="tube #%g mesh true " % self.mksetlist[tbname].id
        tmpString+="color yellow radius %g " % int(self.tuberad[tbname].get())
        tmpString+="modelName Tube_%s modelId %s" % (tbname,self.tbmpid[tbname])
        from Shape import shape_command as sc
        sc(None,tmpString)

    #    Tube Radius
    def TubeRadius_cb(self, event = None):
        if (self.object_style.get() == 'Tube'):
            for tbname in range(0,self.tbmpid.shape[0]):
                radius=self.tuberad[tbname].get()
                if radius == '':
                    return
                radius=int(radius)
                if self.tbrad0[tbname]!=radius:
                    chimera.openModels.close(self.tbmplist[tbname])
                    self.tbrad0[tbname]=radius
                    tmpString="tube #%g mesh true " % self.mksetlist[tbname].id
                    tmpString+="color yellow radius %g " % radius
                    tmpString+="modelName Tube_%s modelId %s" % (tbname,self.tbmpid[tbname])
                    from Shape import shape_command as sc
                    sc(None,tmpString)
            mplist1=chimera.openModels.list()
            self.tbmplist=[ x for x in mplist1 if not x in self.mplist0 ]

    # -------------------------------------------------------------------------
    # Sampling on sphere
    def Sampling_sphere(self):
        import numpy as np

        # sph2cart -- Transform spherical to Cartesian coordinates
        def sph2cart(az, el, r):
            rcos_theta = r * np.cos(el)
            x = rcos_theta * np.cos(az)
            y = rcos_theta * np.sin(az)
            z = r * np.sin(el)
            return x, y, z

        Tspacing=float(self.tangent.get())
        motlist=np.zeros((20,0))
        for nsph in range(self.emdata.shape[1]):
            radius=self.emdata[2,nsph]
            latitudes=np.ceil(np.pi*radius/Tspacing)

            for ele in np.arange(latitudes+1):
                elevation=(ele/latitudes-0.5)*np.pi
                longitudes=np.ceil(2*np.pi*radius*np.cos(elevation)/Tspacing)

                theta=90-np.rad2deg(elevation)
                for azi in np.arange(longitudes):
                    azimuth=azi*2*np.pi/longitudes
                    X,Y,Z=sph2cart(azimuth,elevation,radius)
                    psi=np.rad2deg(azimuth)-270

                    coord=np.zeros((20,1))
                    coord[1:3,0]=self.emdata[1:3,nsph]
                    coord[5,0]=nsph+1
                    coord[7,0]=X+self.emdata[7,nsph]
                    coord[8,0]=Y+self.emdata[8,nsph]
                    coord[9,0]=Z+self.emdata[9,nsph]
                    coord[17,0]=psi
                    coord[18,0]=theta
                    motlist=np.concatenate((motlist, coord), axis=1)

        motlist[10:13,:]=motlist[7:10,:]-np.round(motlist[7:10,:])
        motlist[7:10,:]=np.round(motlist[7:10,:])
        if float(self.rPhi_box.get()):
            phi=np.random.uniform(0,1,motlist.shape[1])*360.0
            motlist[16,:]=phi
        motlist[17,:]=np.mod(motlist[17,:],360)
        motlist[3,:]=range(1,motlist.shape[1]+1)
        motlist[19,:]+=1

        return motlist

    # -------------------------------------------------------------------------
    # Sampling on tube
    def Sampling_tube(self):
        import numpy as np
        from VolumePath import spline
        from qtools import rotation_matrix_y,rotation_matrix_z,rotation_matrix_zxz

        # cart2sph -- Transform Cartesian to spherical coordinates
        def cart2sph(x, y, z):
            hxy = np.hypot(x, y)
            r = np.hypot(hxy, z)
            el = np.arctan2(z, hxy)
            az = np.arctan2(y, x)
            return az, el, r
    
        Tspacing=float(self.tangent.get())
        Aspacing=float(self.axial.get())
        if Aspacing<=0.0:
            Aspacing=Tspacing

        ntube=np.unique(self.emdata[1,:]).shape[0]
        motlist=np.zeros((20,0))
        for ntb in range(ntube):
            subidx=np.where(self.emdata[1,:] == ntb)[0]
            tubemtv=self.emdata[:,subidx]
            radius=tubemtv[2,0]
            #radius=np.unique(tubemtv[2,:])
            segD=0
            for npt in range(tubemtv.shape[1]-1):
                tmpD=np.linalg.norm(tubemtv[7:10,npt]-tubemtv[7:10,npt+1])
                if tmpD>segD:
                    segD=tmpD
            segN=int(np.ceil(2*segD/Aspacing))

            (plist,tlist)=zip(*spline.natural_cubic_spline(tubemtv[7:10,:].T,segN,True))
            #arcs=spline.arc_lengths(plist)
            #joins=np.mod(arcs,Aspacing)

            shifts=np.array([radius,0.0,0.0])
            shifts.shape=(3,1)
            Lspacing=2*np.pi/np.ceil(2*np.pi*radius/Tspacing)
            longitudes=np.rad2deg(np.arange(0,2*np.pi,Lspacing))

            njoin=0
            azimuth, elevation, R=np.rad2deg(cart2sph(tlist[njoin][0],tlist[njoin][1],tlist[njoin][2]))
            for angle in longitudes:
                rotzyz=rotation_matrix_z(azimuth)*rotation_matrix_y(-elevation-90)*rotation_matrix_z(angle)
                rshifts=np.dot(rotzyz,shifts)

                psi=np.rad2deg(np.arctan2(rshifts[1],rshifts[0]))+90
                theta=np.rad2deg(np.arctan2(np.hypot(rshifts[0],rshifts[1]),rshifts[2]))
                rotzxz=rotation_matrix_zxz([0,psi,theta])
                tangent=tlist[njoin]
                tangent.shape=(3,1)
                phi_vec=np.dot(rotzxz.T,tangent)
                phi=np.rad2deg(np.arctan2(phi_vec[1],phi_vec[0]))
                coord=np.zeros((20,1))
                coord[1:3,0]=tubemtv[1:3,0]
                coord[5,0]=ntb+1
                coord[7,0]=rshifts[0]+plist[njoin][0]
                coord[8,0]=rshifts[1]+plist[njoin][1]
                coord[9,0]=rshifts[2]+plist[njoin][2]
                coord[16,0]=phi
                coord[17,0]=psi
                coord[18,0]=theta
                motlist=np.concatenate((motlist, coord), axis=1)

            nnext=1
            while True:
                if njoin+nnext >= len(plist):
                    break

                tmpD=np.linalg.norm(plist[njoin]-plist[njoin+nnext])
                if tmpD<Aspacing:
                    nnext+=1
                else:
                    njoin+=nnext
                    nnext=1
                    if njoin < len(plist):
                        # join
                        azimuth, elevation, R=np.rad2deg(cart2sph(tlist[njoin][0],tlist[njoin][1],tlist[njoin][2]))
                        for angle in longitudes:
                            rotzyz=rotation_matrix_z(azimuth)*rotation_matrix_y(-elevation-90)*rotation_matrix_z(angle)
                            rshifts=np.dot(rotzyz,shifts)
                   
                            psi=np.rad2deg(np.arctan2(rshifts[1],rshifts[0]))+90
                            theta=np.rad2deg(np.arctan2(np.hypot(rshifts[0],rshifts[1]),rshifts[2]))
                            rotzxz=rotation_matrix_zxz([0,psi,theta])
                            tangent=tlist[njoin]
                            tangent.shape=(3,1)
                            phi_vec=np.dot(rotzxz.T,tangent)
                            phi=np.rad2deg(np.arctan2(phi_vec[1],phi_vec[0]))
                            coord=np.zeros((20,1))
                            coord[1:3,0]=tubemtv[1:3,0]
                            coord[5,0]=ntb+1
                            coord[7,0]=rshifts[0]+plist[njoin][0]
                            coord[8,0]=rshifts[1]+plist[njoin][1]
                            coord[9,0]=rshifts[2]+plist[njoin][2]
                            coord[16,0]=phi
                            coord[17,0]=psi
                            coord[18,0]=theta
                            motlist=np.concatenate((motlist, coord), axis=1)

        motlist[10:13,:]=motlist[7:10,:]-np.round(motlist[7:10,:])
        motlist[7:10,:]=np.round(motlist[7:10,:])
        if float(self.rPhi_box.get()):
            phi=np.random.uniform(0,1,motlist.shape[1])*360.0
            motlist[16,:]=phi
        motlist[17,:]=np.mod(motlist[17,:],360)
        motlist[3,:]=range(1,motlist.shape[1]+1)
        motlist[19,:]+=1

        return motlist

    # -------------------------------------------------------------------------
    def ObjectStyleOption(self):
        if (self.object_style.get() == 'Sphere'):
            self.rPhi_box.set(1)
            self.axial_children[0].config(state='disabled')
            self.axial_children[1].config(state='disabled')
        if (self.object_style.get() == 'Tube'):
            self.rPhi_box.set(0)
            self.axial_children[0].config(state='normal')
            self.axial_children[1].config(state='normal')

    # -------------------------------------------------------------------------
    def Options(self):
        self.options_panel.set(not self.options_panel.get())

    #    Pick Particle
    def Display(self):
        import numpy as np

        #    Read The Tomogram and Marker Files
        #tmfile=self.tomo_file.get()
        mkfile=self.marker_file.get()
        #if (not self.isdisplay) and tmfile and mkfile:
        if (not self.isdisplay) and mkfile.endswith(".cmm"):
            #tm=chimera.openModels.open(tmfile)
            #tm[0].data.set_origin((0,0,0))
            #tm[0].data.set_step((1,1,1))

            self.mplist0=chimera.openModels.list()
            mk=chimera.openModels.open(mkfile)
            mplist1=chimera.openModels.list()
            lastmpid=mplist1[-1].id

            self.mksetlist=[ x for x in mplist1 if not x in self.mplist0 ]
            nmkset=len(self.mksetlist)

            nmk=0
            self.emdata=np.zeros((20,0))
            for lp0 in range(0,nmkset):
                tmpcoord=self.mksetlist[lp0].atomCoordinatesArray()
                tmpn=tmpcoord.shape[0]
                nmk += tmpn
                for lp1 in range(0,tmpn):
                    tmpdata=np.zeros((20,1))
                    tmpdata[1,0]=lp0
                    tmpdata[7,0]=tmpcoord[lp1,0]
                    tmpdata[8,0]=tmpcoord[lp1,1]
                    tmpdata[9,0]=tmpcoord[lp1,2]
                    self.emdata=np.concatenate((self.emdata,tmpdata),axis=1)

            if (self.object_style.get() == 'Sphere'):
                self.sphmpid=np.array(range(0,nmk),ndmin=1)+lastmpid+1
                self.SphereFrame(self.panel)
            if (self.object_style.get() == 'Tube'):
                self.tbmpid=np.array(range(0,nmkset),ndmin=1)+lastmpid+1
                self.TubeFrame(self.panel)
            self.isdisplay=1
        else:
            return

    # -------------------------------------------------------------------------
    #    Save
    def Save(self):
        if (not self.isdisplay):
            return

        import qio
        import numpy as np
        emfile=self.marker_file.get()[0:-3]+'em'
        if (self.object_style.get() == 'Sphere'):
            for sphname in range(0,self.sphmpid.shape[0]):
                radius=int(self.sphererad[sphname].get())
                self.emdata[2,sphname]=radius  # row 3 - sphere radius

            if float(self.tangent.get())>0:
                motfile=self.marker_file.get()[0:-4]+'_sphere.em'
                motlist=self.Sampling_sphere()
                motlist[4,:]=float(self.tomoid.get())
                motlist[6,:]=float(self.tomoid.get())
                qio.write(motfile,motlist)

        if (self.object_style.get() == 'Tube'):
            for tbname in range(0,self.tbmpid.shape[0]):
                radius=int(self.tuberad[tbname].get())
                tubebone=np.where(self.emdata[1,:] == tbname)[0]
                if (len(tubebone) > 1 ):
                    self.emdata[2,tubebone]=radius  # row 3 - tube radius

            if float(self.tangent.get())>0:
                motfile=self.marker_file.get()[0:-4]+'_tube.em'
                motlist=self.Sampling_tube()
                motlist[4,:]=float(self.tomoid.get())
                motlist[6,:]=float(self.tomoid.get())
                qio.write(motfile,motlist)

        self.emdata[4,:]=float(self.tomoid.get())
        self.emdata[6,:]=float(self.tomoid.get())
        qio.write(emfile,self.emdata)

    # -------------------------------------------------------------------------
    #    Reset
    def Reset(self):
        if (not self.isdisplay):
            #self.tomo_file.set('')
            self.marker_file.set('')
            self.object_style.set('Sphere',invoke_callbacks=False)
            return

        for mkname in range(0,len(self.mksetlist)):
            chimera.openModels.close(self.mksetlist[mkname])
        if len(self.sphmpid):
            for sphname in range(0,self.sphmpid.shape[0]):
                chimera.openModels.close(self.sphmplist[sphname])
        if len(self.tbmpid):
            for tbname in range(0,self.tbmpid.shape[0]):
                chimera.openModels.close(self.tbmplist[tbname])
        self.isdisplay=0
        #self.tomo_file.set('')
        self.marker_file.set('')
        self.tomoid.set(0)
        self.object_style.set('Sphere',invoke_callbacks=False)
        self.objFrame.destroy()

        #self.sphereScale=[]
        #self.sphererad=[]
        #self.tubeScale=[]
        #self.tuberad=[]

    # -------------------------------------------------------------------------
    #    Combine
    def Combine(self):
        import numpy as np
        from glob import glob
        import VolumeData
        import qio

        motivefiles=glob(self.comb_fileI.get())
        motivefiles.sort()
        if len(motivefiles)<2:
            return
        if (self.comb_fileO.get() == ''):
            #self.comb_bgO.configure(bg="red")
            return
        #if isfile(self.comb_fileO.get()):
        #    self.comb_bgO.configure(bg="red")
        #    return

        #self.comb_bgO.configure(bg="white")
        combined=np.array([])
        combined.shape=(20,0)
        nparticle=0
        for mtvlst in motivefiles:
            print mtvlst
            coordfile=VolumeData.open_file(mtvlst,'tom_em')
            coord=coordfile[0].full_matrix()[0,:,:].transpose()
            coord[5,:]+=nparticle
            combined=np.concatenate((combined, coord), axis=1)
            nparticle=coord[5,-1]

        if float(self.reNo_box.get()):
            combined[3,:]=range(1,combined.shape[1]+1)
        qio.write(self.comb_fileO.get(),combined)

    # -------------------------------------------------------------------------
    #    Shift
    def Shift(self):
        import numpy as np
        import qio
        from qtools import rotation_matrix_zxz
        from os.path import isfile
        import VolumeData

        if not isfile(self.shift_fileI.get()):
            #self.shift_bgI.configure(bg="red")
            return
        #self.shift_bgI.configure(bg="white")

        if (self.shift_fileO.get() == ''):
            #self.shift_bgO.configure(bg="red")
            return
        #if isfile(self.shift_fileO.get()):
        #    self.shift_bgO.configure(bg="red")
        #    return
        #self.shift_bgO.configure(bg="white")

        motfile=self.shift_fileI.get()
        shift_x=float(self.shift_x.get())
        shift_y=float(self.shift_y.get())
        shift_z=float(self.shift_z.get())
        apixelI=float(self.apix_in.get())
        apixelO=float(self.apix_ou.get())
        if shift_x==0. and shift_y==0. and shift_z==0. and apixelI==apixelO:
            return

        motlistfile=VolumeData.open_file(motfile,'tom_em')
        motlist=motlistfile[0].full_matrix()[0,:,:].transpose()
        if shift_x or shift_y or shift_z:
            shifts=np.array([shift_x, shift_y, shift_z])
            shifts.shape=(3,1)

            for lpn in range(motlist.shape[1]):
                angles=motlist[16:19,lpn]
                rot=np.array(rotation_matrix_zxz(angles))
                rshifts=np.dot(rot,shifts)
                motlist[10,lpn]+=rshifts[0]
                motlist[11,lpn]+=rshifts[1]
                motlist[12,lpn]+=rshifts[2]

        motlist[7:10,:]+=motlist[10:13,:]
        if apixelI!=apixelO:
            binfac=apixelI/apixelO
            corrector=binfac-1
            motlist[7:10,:]=motlist[7:10,:]*binfac
            motlist[7:10,:]=motlist[7:10,:]-corrector
        motlist[10:13,:]=motlist[7:10,:]-np.round(motlist[7:10,:])
        motlist[7:10,:]=np.round(motlist[7:10,:])

        qio.write(self.shift_fileO.get(),motlist)
# -------------------------------------------------------------------------
def pickparticledialog(create=False):
    from chimera import dialogs
    return dialogs.find(PickParticleDialog.name, create=create)

# -----------------------------------------------------------------------------
def show_pickparticledialog():
    from chimera import dialogs
    return dialogs.display(PickParticleDialog.name)

# -------------------------------------------------------------------------

chimera.dialogs.register(PickParticleDialog.name, PickParticleDialog)

#dir, file = os.path.split(__file__)
#icon = os.path.join(dir, 'PickParticle.tiff')
#chimera.tkgui.app.toolbar.add(icon, lambda d=chimera.dialogs.display, n=PickParticleDialog.name: d(n), 'Pick particle in map.', None)

